package cn.yw.nhyw.nhywjtxcrzgl.action;


import java.io.File;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.xwork.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.ibatis.SqlMapClientCallback;
import org.springframework.stereotype.Component;

import com.ibatis.sqlmap.client.SqlMapExecutor;

import cn.base.aspect.OperateType;
import cn.base.bean.BaseAction;
import cn.base.excel.ExcelCol;
import cn.base.excel.ExportEngine;
import cn.base.util.CommUtils;
import cn.base.util.Constants;
import cn.base.util.DateUtil;
import cn.base.util.LogConstants;
import cn.base.util.StringUtil;
import cn.base.util.Struts2Utils;
import cn.bsystem.ptuserrole.model.PtyhBean;
import cn.yw.nhyw.nhywjtxcrzgl.service.NhywjtssxcsbService;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

@SuppressWarnings({"all"})
@Component("nhywjtssxcsbAction")
public class NhywjtssxcsbAction extends BaseAction{
	private static final long serialVersionUID = 1L;
	private static Logger iLog = Logger.getLogger(NhywjtssxcsbAction.class);
	
	@Autowired
	private NhywjtssxcsbService service;
	
	/**
	 * 分页
	 */
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="listNhywjtssxcsbByPage")
	public void listNhywjtssxcsbByPage(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listNhywjtssxcsbByPage(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-listNhywjtssxcsbByPage-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	/**
	 * 根据服务商编号查询监控设备List
	 */
	public void listJksbByFwsbh(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			Struts2Utils.renderJson(this.service.listJksbByFwsbh(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-listJksbByFwsbh-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	/**
	 * 根据服务商编号查询交通监控设备List
	 */
	public void listJtsbByFwsbh(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			int page = Integer.parseInt(Struts2Utils.getParameter("page"));
			int rows = Integer.parseInt(Struts2Utils.getParameter("rows"));
			int start = ( (page == 0 ?  1 : page ) - 1) * rows ;
			map.put("start",start );
			map.put("limit",rows );
			String xcsblx = map.get("xcsblx")+"";
			Map result = null;
			switch(xcsblx){
				case Constants.JT_BZ :
					result = this.service.listJtsbByFwsbh_bz(map);
					break;
				case Constants.JT_BX :
					result = this.service.listJtsbByFwsbh_bx(map);
					break;
				case Constants.JT_HL :
					result = this.service.listJtsbByFwsbh_hl(map);
					break;
				case Constants.JT_XHD :
					result = this.service.listJtsbByFwsbh_xhd(map);
					break;
				default:
					result = this.service.listJtsbByFwsbh_ydp(map);
				
			}
			Struts2Utils.renderJson(result);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-listJtsbByFwsbh-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	/**
	 * 批量插入巡查单关联设备
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="batch_add_Nhywjtssxcsb")
	public void batch_add_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			String xcsblx = (String) map.get("xcsblx");
			String xcdh = (String) map.get("xcdh");
			String param = (String) map.get("param");
			JSONArray json = JSONArray.fromObject(param);
			JSONObject object = null;
			if(json.size()>0){
				service.batch_add_Nhywjtssxcsb(xcdh,xcsblx,json);
			}
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("YwvideochannelsetlistAction-batch_add_Nhywjtssxcsb()-error:" +e);
			Struts2Utils.renderJson(null);
		}
		
		
	}
	/**
	 * 查询总数
	 */
	//@OperateType(value = LogConstants.LOG_QUERY ,info ="count_Nhywjtssxcsb")
	public void count_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.count_Nhywjtssxcsb(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-count_Nhywjtssxcsb-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 Nhywjtssxcsb
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="query_Nhywjtssxcsb")
	public void query_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.query_Nhywjtssxcsb(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-query_Nhywjtssxcsb-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 查询 一条Nhywjtssxcsb
	 */
	@OperateType(value = LogConstants.LOG_GET ,info ="get_Nhywjtssxcsb")
	public void get_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Struts2Utils.renderJson(this.service.get_Nhywjtssxcsb(map));
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbActionquery_Nhywjtssxcsb-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="deleteNhywjtssxcsb")
	public void delete_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!CommUtils.isEmpty(map)){
				int result = service.delete_Nhywjtssxcsb(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}else{
				 throw new Exception("请正确的选择删除记录!!!");
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-delete_Nhywjtssxcsb-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}

	/**
	 * 插入
	 */
	@OperateType(value = LogConstants.LOG_ADD ,info ="insert_Nhywjtssxcsb")
	public void insert_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(StringUtil.checkEmpty(map.get("xh"))){
				map.put("xh",StringUtil.getUUID());
			}
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Nhywjtssxcsb(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					service.insert_Nhywjtssxcsb(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				service.insert_Nhywjtssxcsb(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}			
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-insert_Nhywjtssxcsb()-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 修改
	 */
	@OperateType(value = LogConstants.LOG_UPDATE ,info ="update_Nhywjtssxcsb")
	public void update_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			if(!StringUtil.checkEmpty(map.get("checkparam"))){
				Map sMap = new HashMap();
				sMap.put("tableparam", map.get("checkparam"));
				List ls = service.query_Nhywjtssxcsb(sMap);
				if(!StringUtil.checkEmpty(ls)||ls.size()>0){
					Struts2Utils.renderJson(Constants.SAME);
				}else{
					int result = service.update_Nhywjtssxcsb(map);
					Struts2Utils.renderJson(Constants.SUCCESS);
				}
			}else{
				int result = service.update_Nhywjtssxcsb(map);
				Struts2Utils.renderJson(Constants.SUCCESS);
			}
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-update_Nhywjtssxcsb-error: " +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 批量删除
	 */
	@OperateType(value = LogConstants.LOG_DELETE ,info ="batch_delete_Nhywjtssxcsb")
	public void batch_delete_Nhywjtssxcsb(){
		Map map = Struts2Utils.getRequestParameterMap();
		try {
			Map m = new HashMap();
			m.put("keyword", map.get("keyword"));
			int result = service.batch_delete_Nhywjtssxcsb(m);
			Struts2Utils.renderJson(Constants.SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-batch_delete_Nhywjtssxcsb-error:" +e);
			Struts2Utils.renderJson(null);
		}
	}
	
	/**
	 * 导出Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_EXPORT ,info ="exp_Nhywjtssxcsb")
	public void exp_Nhywjtssxcsb(){
		try {
			Map map = Struts2Utils.getRequestParameterMap();
			map.put("start",0 );
			map.put("limit",5000);
			List<Map> sList = service.query_Nhywjtssxcsb(map);		
			List<HashMap> expList = new ArrayList<HashMap>();
			for(Map m : sList){
				Map exportMap = new HashMap();
				exportMap.put("yhzh", m.get("yhzh"));
				expList.add((HashMap) exportMap);
			}
			int excelNum = 2;
			ExcelCol[] cells = new ExcelCol[excelNum];
			String[] zdbm = {"yhzh", "yhmc",};
			String[] zdmc = {"用户账号", "用户名称"};
			for(int i=0;i<excelNum;i++){
				cells[i] = new ExcelCol();
				cells[i].setColKey(zdbm[i]);
				cells[i].setColName(zdmc[i]);
			}		
			SimpleDateFormat formart = new SimpleDateFormat("yyyy-MM-dd");   
        	String dateTime=formart.format(new Date()); 
			Map params = new HashMap();
			params.put("fileName", "交通设施巡查设备-"+dateTime);
			params.put("sheetName", "交通设施巡查设备");
			params.put("header", "交通设施巡查设备");	
			new ExportEngine().exportCommData(params, cells, (ArrayList)map.get("rows"), Struts2Utils.getResponse());
		} catch (Exception e) {
			e.printStackTrace();
			iLog.error("NhywjtssxcsbAction-exoprtExcel-error:" +e);
			
		}
	}
	*/
	
	/**
	 * 导入Excel
	 */
	/*
	//@OperateType(value = LogConstants.LOG_IMPORT ,info ="imp_Nhywjtssxcsb")
	public String imp_Nhywjtssxcsb(String excelFile,Object user) {
		String rs = "导入格式有误!";
		int rowNum = 0;
		int dataCount = 0;
		int successNum = 0;
		int repeatNum = 0;
		int failNum = 0;
		try {
		
			ExcelReader readExcel = new ExcelReader();
			readExcel.openFile(excelFile);
			readExcel.setSheetNum(0);
			int count = readExcel.getRowCount();
			iLog.info("总行数count--->" + count);
			rs = " 导入数据成功！总共"+ dataCount +"条数据,重复"+repeatNum+"条数据！失败"+failNum+"条数据!";
			File file = new File(excelFile);
			if(file.exists()){
				file.delete();
			}
		} catch (Exception e) {
			if (rowNum > 3) {
				rs = "资源部分导入(更新)失败！Excel第" + rowNum + "行起未导入(更新)成功！";
			} else {
				rs = "资源导入(更新)失败！";
			}
			iLog.error("NhywjtssxcsbAction-imp_Nhywjtssxcsb-error:" +e);
			e.printStackTrace();
		}		
		return rs;
	}
	*/
}
